#include <e32std.h>
#include <e32base.h>
#include <apgtask.h>
#include <eikenv.h>

#include "Python.h"
#include "symbian_python_ext_util.h"


TBool TryToBringForeground(const TDesC& aCaption)
{
	
	TApaTaskList taskList(CEikonEnv::Static()->WsSession());
	TApaTask task(taskList.FindApp(aCaption));

	if (task.Exists())
	{
		task.BringToForeground();		
	}
	return task.Exists();
}

static PyObject* switch_to_fg(PyObject* /*self*/, PyObject *args)
{
	char* b = NULL;	
	TInt l = 0;

	if (!PyArg_ParseTuple(args, "u#", &b, &l))
	{
		return 0;
	}
	
	TPtrC caption((TUint16*)b, l);

	if (TryToBringForeground(caption))
	{
		Py_INCREF(Py_True);
		return Py_True;
	}
	else
	{
		Py_INCREF(Py_False);
		return Py_False;
	}	
}


static const PyMethodDef appswitch_methods[] =
{
	{"switch_to_fg", (PyCFunction)switch_to_fg, METH_VARARGS},
	{0, 0} /* sentinel */
};

DL_EXPORT(void) init_iapconnect()
{
	Py_InitModule("appswitch", (PyMethodDef*) appswitch_methods);	
}

GLDEF_C TInt E32Dll(TDllReason)
{
	return KErrNone;
}


